---
title: RTCDTMFSender
slug: Web/API/RTCDTMFSender
tags:
  - Audio
  - DTMF
  - Interface
  - Media
  - PSTN
  - RTCDTMFSender
  - Reference
  - Telephony
  - Touch-tone
  - WebRTC
  - WebRTC API
---
<div>{{APIRef("WebRTC")}}</div>

<div id="interface_description">
<p>The <strong><code>RTCDTMFSender</code></strong> interface provides a mechanism for transmitting {{Glossary("DTMF")}} codes on a <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC</a> {{domxref("RTCPeerConnection")}}. You gain access to the connection's <code>RTCDTMFSender</code> through the {{domxref("RTCRtpSender.dtmf")}} property on the audio track you wish to send DTMF with.</p>

<p>The primary purpose for WebRTC's DTMF support is to allow WebRTC-based communication clients to be connected to a {{interwiki("wikipedia", "public-switched telephone network")}} (PSTN) or other legacy telephone service, including extant voice over IP (VoIP) services. For that reason, DTMF can't be used between two WebRTC-based devices, because there is no mechanism provided by WebRTC for receiving DTMF codes.</p>

<p>{{InheritanceDiagram}}</p>
</div>

<h2 id="Properties">Properties</h2>

<dl id="property_definitions">
 <dt>{{domxref("RTCDTMFSender.toneBuffer")}} {{ReadOnlyInline}}</dt>
 <dd>A {{domxref("DOMString")}} which contains the list of DTMF tones currently in the queue to be transmitted (tones which have already been played are no longer included in the string). See {{domxref("RTCDTMFSender.toneBuffer", "toneBuffer")}} for details on the format of the tone buffer.</dd>
</dl>

<h2 id="methods">Methods</h2>

<dl id="method_definitions">
 <dt>{{domxref("RTCDTMFSender.insertDTMF()")}}</dt>
 <dd>Given a string describing a set of DTMF codes and, optionally, the duration of and inter-tone gap between the tones, <code>insertDTMF()</code> starts sending the specified tones. Calling <code>insertDTMF()</code> replaces any already-pending tones from the <code>toneBuffer</code>. You can abort sending queued tones by specifying an empty string (<code>""</code>) as the set of tones to play.</dd>
</dl>

<h2 id="Events">Events</h2>

<p>Listen to these events using {{domxref("EventTarget.addEventListener", "addEventListener()")}} or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface.</p>

<dl>
 <dt>{{domxref("RTCDTMFSender.tonechange_event", "tonechange")}}</dt>
 <dd>The <code>tonechange</code> event is sent to the <code>RTCDTMFSender</code> instance's event handler to indicate that a tone has either started or stopped playing.<br>
 Also available using the {{domxref("RTCDTMFSender.ontonechange", "ontonechange")}} event handler property.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>See the article <a href="/en-US/docs/Web/API/WebRTC_API/Using_DTMF">Using DTMF with WebRTC</a> for a full example.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("WebRTC 1.0", "#rtcdtmfsender", "RTCDTMFSender")}}</td>
   <td>{{Spec2("WebRTC 1.0")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCDTMFSender")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Using_DTMF">Using DTMF with WebRTC</a></li>
 <li>{{domxref("RTCRtpSender.dtmf")}}</li>
 <li>{{domxref("RTCPeerConnection")}}</li>
 <li>{{domxref("RTCRtpSender")}}</li>
</ul>
